<?php

class TopicController extends Controller
{
	/**
	 * @var string the default layout for the views. Defaults to '//layouts/column2', meaning
	 * using two-column layout. See 'protected/views/layouts/column2.php'.
	 */
	public $layout='forum';

	/**
	 * @return array action filters
	 */
	public function filters()
	{
		return array(
			'accessControl', // perform access control for CRUD operations
		);
	}

	/**
	 * Specifies the access control rules.
	 * This method is used by the 'accessControl' filter.
	 * @return array access control rules
	 */
	public function accessRules()
	{
		return array(
		
		);
	}
	public function allowedActions()
	{
		return 'create,view,index,update,saveContent,changeCategory,deleteAttachment,saveTitle,search,sCaptcha';		
	}
	public function actions()
    {
        return array(
            'upload'=>array(
                'class'=>'application.modules.sforum.components.xupload.actions.XUploadAction',
        		'subfolderVar' => 'topic_id',
				'path' =>Yii::app() -> getBasePath() . "/../uploads",
                'publicPath' => Yii::app() -> getBaseUrl() . "/uploads",
            ),
        );
    }


    public function actionsCaptcha()
    {
    $aResponse['error'] = false;
	
		if(isset($_POST['action']) && isset($_POST['qaptcha_key']))
		{
			$_SESSION['qaptcha_key'] = false;	
			
			if(htmlentities($_POST['action'], ENT_QUOTES, 'UTF-8') == 'qaptcha')
			{
				$_SESSION['qaptcha_key'] = $_POST['qaptcha_key'];
				echo json_encode($aResponse);
			}
			else
			{
				$aResponse['error'] = true;
				echo json_encode($aResponse);
			}
		}
		else
		{
			$aResponse['error'] = true;
			echo json_encode($aResponse);
		}
    }
    /** respond to search **/
    public function actionSearch()
    {
        $criteria=new CDbCriteria;                
	    $criteria->condition='content LIKE :content OR title like :title LIMIT 20';
		$criteria->params=array(
			':content'=>'%'.$_POST['search'].'%',
			':title'=>'%'.$_POST['search'].'%'
			);
		$topics = Topic::model()->findAll($criteria);
		$content = $this->renderPartial('_search_results',array('topics'=>$topics),true);
		echo CJSON::encode(array('status'=>'success','content'=>$content));
	}
    /** save content after edit **/

    public function actionsaveContent()
    {
    	if(isset($_POST['content'])){
    		$model = $this->loadModel($_POST['id']);
    		$model->content = $_POST['content'];
    		
    		if($model->save())
    		{
    			echo CJSON::encode(array('status'=>'success','content'=>SForumModule::parseText($model->content)));
    		}

    	}
    }
    public function actionChangeSticky()
    {
    	$model = $this->loadModel($_POST['id']);
    	$model->sticky = $_POST['sticky'];
    	
    	if($model->save())
    	{
    		echo CJSON::encode(array('status'=>'success'));
    	}
    }


        /** save content after edit **/

    public function actionSaveTitle()
    {
    	$id = str_replace('topic_title','',$_POST['id']);
    	$model = $this->loadModel($id);
    	$model->title = $_POST['title'];
    	
    	if($model->save())
    	{
    		echo CJSON::encode(array('status'=>'success','title'=>$model->title));
    	}
    }

    public function actiondeleteAttachment()
    {
    	if(Yii::app()->request->isAjaxRequest)
    	{
	    	if(unlink($_POST['filePath']))
	    	{
	    		echo CJSON::encode(array('status'=>'success'));
	    	}
    	}

    }


    public function actionchangeCategory()
	{
		$model = $this->loadModel($_POST['topic']);
		$model->category = $_POST['category'];
		if($_POST['category']=='1') //trashbin
			$model->status = 0;
		else
			$model->status = 1;
		
		if($model->save())
		{
			echo CJSON::encode(array('status'=>'success','message'=>$model->categoryModel->name));
		}
	}	

	/**
	 * Displays a particular model.
	 * @param integer $id the ID of the model to be displayed
	 */
	public function actionView($id)
	{	
		$criteria=new CDbCriteria(array(
			'condition'=>'topicid='.$id,
			'order'=>'created',
			'with'=>'',
		));

		$commentProvider=new CActiveDataProvider('Comment', array(
			'pagination'=>array(
				'pageSize'=>Yii::app()->controller->module->commentsPerPage,
			),
			'criteria'=>$criteria,
		));

		$model = $this->loadModel($id);
		$owner = false;
		if($model->userid==Yii::app()->user->id)
			$owner = true;
		$render = array('model'=>$model,'owner'=>$owner,'commentProvider'=>$commentProvider);
		if(Yii::app()->request->isAjaxRequest)
		{
			echo $this->renderPartial('view',$render,true);
		}else
		{
			$this->render('view',$render);
		}
	}


	/**
	 * Creates a new model.
	 * If creation is successful, the browser will be redirected to the 'view' page.
	 */
	public function actionCreate($category=false,$name="")
	{

		$model=new Topic;

		if(isset($_POST['Topic']))
		{
			$model->attributes=$_POST['Topic'];
			if($model->save())
			{
				
				echo CJSON::encode(array('status'=>'success','id'=>$model->id));
				return;
			}	
		}
		$this->renderPartial('create',array(
			'model'=>$model,
			'category'=>$category,
		));
	}

	/**
	 * Updates a particular model.
	 * If update is successful, the browser will be redirected to the 'view' page.
	 * @param integer $id the ID of the model to be updated
	 */
	public function actionUpdate($id)
	{
		$model=$this->loadModel($id);

		// Uncomment the following line if AJAX validation is needed
		$this->performAjaxValidation($model);

		if(isset($_POST['Topic']))
		{
			$model->attributes=$_POST['Topic'];
			if($model->save())
				$this->redirect(array('view','id'=>$model->id));
		}

		$this->render('update',array(
			'model'=>$model,
		));
	}

	/**
	 * Deletes a particular model.
	 * If deletion is successful, the browser will be redirected to the 'admin' page.
	 * @param integer $id the ID of the model to be deleted
	 */
	public function actionDelete($id)
	{
		if(Yii::app()->request->isPostRequest)
		{
			// we only allow deletion via POST request
			$this->loadModel($id)->delete();

			// if AJAX request (triggered by deletion via admin grid view), we should not redirect the browser
			if(!isset($_GET['ajax']))
				$this->redirect(isset($_POST['returnUrl']) ? $_POST['returnUrl'] : array('admin'));
		}
		else
			throw new CHttpException(400,'Invalid request. Please do not repeat this request again.');
	}

	/**
	 * Lists all models.
	 */
	public function actionIndex()
	{
		$dataProvider=new CActiveDataProvider('Topic');
		$this->render('index',array(
			'dataProvider'=>$dataProvider,
		));
	}

	/**
	 * Manages all models.
	 */
	public function actionAdmin()
	{
		$model=new Topic('search');
		$model->unsetAttributes();  // clear any default values
		if(isset($_GET['Topic']))
			$model->attributes=$_GET['Topic'];

		$this->render('admin',array(
			'model'=>$model,
		));
	}

	/**
	 * Returns the data model based on the primary key given in the GET variable.
	 * If the data model is not found, an HTTP exception will be raised.
	 * @param integer the ID of the model to be loaded
	 */
	public function loadModel($id)
	{
		$model=Topic::model()->findByPk($id);
		if($model===null)
			throw new CHttpException(404,'The requested page does not exist.');
		return $model;
	}

	/**
	 * Performs the AJAX validation.
	 * @param CModel the model to be validated
	 */
	protected function performAjaxValidation($model)
	{
		if(isset($_POST['ajax']) && $_POST['ajax']==='topic-form')
		{
			echo CActiveForm::validate($model);
			Yii::app()->end();
		}
	}
}
